\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ This program provides the computational steps to prove Section 6.2


D = 2
K.<x> = QuadraticField(D)
l = K.embeddings(RR)
m = [(l[k](x),k) for k in xrange(2)]
phi = l[max(m)[1]]

D2 = [ [12,2, 3, 1/2*x],[12,2, 9, 1/2*x], [12,10, 3, 1/2*x],[12,10, 9, 1/2*x]]

D33 = [ [12,4, 1, 1/2*x + 3/2], [12,4, 5, 1/2*x - 3/2], [12,4, 7, 1/2*x + 3/2], [12,4, 11, 1/2*x - 3/2],[12,8, 1, 1/2*x - 3/2], [12,8, 5, 1/2*x + 3/2], [12,8, 7, 1/2*x - 3/2], [12,8, 11, 1/2*x + 3/2]]

D3 = [[12,1, 3, 1/2*x - 1/2], [12,1, 9, 1/2*x - 1/2], [12,5, 3, 1/2*x + 1/2], [12,5, 9, 1/2*x + 1/2],[12,7, 3, 1/2*x + 1/2], [12,7, 9, 1/2*x + 1/2], [12,11, 3, 1/2*x - 1/2], [12,11, 9, 1/2*x - 1/2]]

D6 = [ [12,4, 3, 1/2*x],   [12,4, 9, 1/2*x], [12,8, 3, 1/2*x],  [12,8, 9, 1/2*x]]

def dual_basis(r):
    Re = r.trace()/2
    Im = (r-r.norm()/r)/2
    return [(1/2 - Re/(2*Im)) ,(1/(2*Im))]

# CHECK WHETHER A MATRIX M IS AN INTEGRAL POSITIVE MATRIX
def M_is_integral_positive(M):
    return (M[0][0] in NN) and (M[0][1] in NN) and (M[1][0] in NN) and (M[1][1] in NN)

# GALOIS CONJUGATE
def galois(r):
    if r in QQ: return r
    return r.norm()/r


def M_intersection_matrix(r2_hor,r2_ver,gamma,give_w = False):
    s = dual_basis(r2_hor)
    h = [s[0]/2,s[1]]
    h_galois= [galois(r) for r in h]
    H = matrix([h,h_galois]).transpose()
    
    w = [h[0]/gamma,r2_ver*h[0]/gamma]
    if give_w: print "THE WIDTHS OF THE VERTICAL DIRECTION ARE: " + str(w)
    w_bis = [h[1]/gamma,r2_ver*h[1]/gamma]
    w_galois = [galois(r) for r in w]
    w_bis_galois = [galois(r) for r in w_bis]
    W = matrix([w,w_galois]).transpose()
    W_bis = matrix([w_bis,w_bis_galois]).transpose()
    return [(W*(H.inverse())).transpose(),(W_bis*(H.inverse())).transpose()]    
    
def M_intersection_matrix_2d_method(r2_hor,r2_ver,gamma,ok=False):
    s = dual_basis(r2_hor)
    h = [s[0]/2,s[1]]
    h_galois= [galois(r) for r in h]
    H = matrix([h,h_galois]).transpose()
    
    w = [2*h[0]/gamma,2*r2_ver*h[0]/gamma]
    if ok: print w
    w_galois = [galois(r) for r in w]
    W = matrix([w,w_galois]).transpose()
    return (W*(H.inverse())).transpose()


def possible_periods(N,n,m,r2):
        p = -n/N + r2*m/N # simplest relative period
	periods = [ ]
	for k in xrange(-2,2+1):
	   for l in xrange(-1,2):
		pe = p + k + l*r2
                if phi(pe) > 0 and phi(pe-r2)<0:
                   #print "[k,l]= " + str([k,l]) + " " + str(pe)
		   periods.append([pe,k,l])
	return periods

def possible_matrices_22(sol,bis=False):
    for i in sol:
        for j in sol:
            poss_periods = possible_periods(j[0],j[1],j[2],j[3])
            for pp in poss_periods:
                beta = pp[0]
                if bis: M = M_intersection_matrix(i[3],j[3],beta)
                if not bis: M = [M_intersection_matrix_2d_method(i[3],j[3],beta),0]
                if not bis:
                    if M_is_integral_positive(M[0]) and mod(M[0][0,1],2)==0:
                        #M_intersection_matrix_2d_method(i[3],j[3],beta,True)
                        print [M[0],i[3]]; print
                if bis:
                    if M_is_integral_positive(M[1]) and mod(M[1][0,1],2)==0:
                        #M_intersection_matrix_2d_method(i[3],j[3],beta,True)
                        print [M[1],i[3]]; print
    return "END"